#include <dbus-c++/dbus.h>
#include <iostream>
#include <stdlib.h>
#include <signal.h>

#include "TestVariant.h"

#define SERVICE_NAME "org.freedesktop.DBus.TestVariant.variant"

DBus::BusDispatcher disp;

//////////////////////////////////////////////////////////////////////////////
void signal_handler(int sig)
{
  switch (sig) {
  case SIGTERM:
  case SIGINT:
    disp.leave();
    break;
  default:;
  }
}

//////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{

  //attach a signal handler
  if (signal(SIGTERM, signal_handler) == SIG_ERR) {
    std::cerr << "Unable to attach SIGTERM signale handler.\n";
  }
  else if (signal(SIGINT, signal_handler) == SIG_ERR) {
    std::cerr << "Unable to attach SIGINI signale handler.\n";
  }

  DBus::default_dispatcher = &disp;

  DBus::Connection conn = DBus::Connection::SessionBus();
  conn.request_name(SERVICE_NAME);
  std::cerr << "Server Listening...\n";

  TestVariant test(conn);
  disp.enter();
  return 0;
}
